local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

a.spells["auto_attack"] = {
	ID = 6603--[[Auto Attack]],
	EnemyTargetNeeded = 1,
	Melee = 1,
	NotIfActive = 1,
	CheckFirst = function(z)
		z.FlashColor = s.If(x.ActiveEnemy, "White", "Pink")
		return x.NoCC
	end,
}

a.StaminaBuffs = {
	21562--[[Power Word: Fortitude]],
	469--[[Commanding Shout]],
	109773--[[Dark Intent]],
	90364--[[Qiraji Fortitude]]
}

a.APBuffs = {
	57330--[[Horn of Winter]],
	19506--[[Trueshot Aura]],
	6673--[[Battle Shout]]
}

a.spells["Battle Stance"] = {
	Type = "form",
	ID = 2457--[[Battle Stance]],
	Buff = 2457--[[Battle Stance]],
	BuffUnit = "player",
	FlashColor = "Green",
	NoGCD = true,
}

a.spells["synapse_springs"] = {
	Type = "item",
	NoRangeCheck = true,
	Check = function(z)
		local gloves = GetInventoryItemID("player", 10)
		z.ID = gloves
		z.FlashID = gloves
		return x.InCombat and s.ItemCooldown(gloves) == 0
	end,
	NoGCD = true,
	FlashColor = "Yellow",
	Continue = true,
}

a.spells["synapse_springs,if=!talent.bloodbath.enabled&debuff.colossus_smash.up|buff.bloodbath.up"] = {
	Type = "item",
	NoRangeCheck = true,
	Override = function(z)
		local gloves = GetInventoryItemID("player", 10)
		z.ID = gloves
		return x.InCombat and x.ActiveEnemy and s.ItemCooldown(gloves) == 0 and (not s.HasTalent(12292--[[Bloodbath]]) and x.DebuffColossusSmashRemains > 0 or s.BuffDuration(12292--[[Bloodbath]], "player") > 0)
	end,
	NoGCD = true,
	FlashColor = "Yellow",
	Continue = true,
}

a.spells["Defensive Stance"] = {
	Type = "form",
	ID = 71--[[Defensive Stance]],
	Buff = 71--[[Defensive Stance]],
	BuffUnit = "player",
	FlashColor = "Green",
	NoGCD = true,
}

a.spells["Charge"] = {
	ID = 100--[[Charge]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and not s.MeleeDistance("target")
	end,
	NoGCD = true,
	FlashColor = "Yellow",
}

a.spells["Berserker Rage (Protection)"] = {
	ID = 18499--[[Berserker Rage]],
	Melee = true,
	Check = function(z)
		return x.ShouldTemporaryBuff and x.ActiveEnemy and x.Rage <= 50
	end,
	NoGCD = true,
	FlashColor = "Yellow",
}

a.spells["Berserker Rage"] = {
	ID = 18499--[[Berserker Rage]],
	Buff = 12880--[[Enrage]],
	BuffUnit = "player",
	Melee = true,
	Check = function(z)
		return x.ShouldTemporaryBuff and x.ActiveEnemy and x.Rage + 10 < x.MaxRage
	end,
	NoGCD = true,
	FlashColor = "Yellow",
}

a.spells["berserker_rage,if=buff.enrage.remains<1&cooldown.bloodthirst.remains>1"] = {
	ID = 18499--[[Berserker Rage]],
	Buff = 12880--[[Enrage]],
	EarlyRefresh = 1,
	BuffUnit = "player",
	Melee = true,
	Check = function(z)
		return x.ShouldTemporaryBuff and x.ActiveEnemy and x.CooldownBloodthirstRemains > 1
	end,
	NoGCD = true,
	FlashColor = "Yellow",
}

a.spells["Pummel"] = {
	ID = 6552--[[Pummel]],
	EnemyTargetNeeded = true,
	Interrupt = true,
	NoGCD = true,
	FlashColor = "Aqua",
}

a.spells["Disrupting Shout"] = {
	ID = 102060--[[Disrupting Shout]],
	EnemyTargetNeeded = true,
	Interrupt = true,
	NoGCD = true,
	FlashColor = "Aqua",
}

a.spells["Shield Slam"] = {
	ID = 23922--[[Shield Slam]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.Rage + 20 < x.MaxRage
	end,
}

a.spells["Revenge"] = {
	ID = 6572--[[Revenge]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.Rage + 15 < x.MaxRage
	end,
}

a.spells["Weakened Blows"] = {
	ID = 6343--[[Thunder Clap]],
	EnemyTargetNeeded = true,
	Debuff = 115798--[[Weakened Blows]],
	EarlyRefresh = 3,
	Melee = true,
	Check = function(z)
		return x.NoCC
	end,
}

a.spells["Thunder Clap"] = {
	ID = 6343--[[Thunder Clap]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC
	end,
}

a.spells["Whirlwind"] = {
	ID = 1680--[[Whirlwind]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		if x.AoE > 2 then
			z.Continue = false
			z.FlashColor = "white"
		else
			z.Continue = true
			z.FlashColor = "Pink"
		end
		return x.NoCC
	end,
}

a.spells["Sweeping Strikes"] = {
	ID = 12328--[[Sweeping Strikes]],
}

a.spells["Devastate"] = {
	ID = 20243--[[Devastate]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC
	end,
}

a.spells["Shield Block"] = {
	ID = 2565--[[Shield Block]],
	Buff = 2565--[[Shield Block]],
	BuffUnit = "player",
	Check = function(z)
		return x.ShouldTemporaryBuff and x.ActiveEnemy and (x.whb >= x.wha or UnitName("target") == "Tortos") and x.whb > s.MaxHealth("player") / 20
	end,
	NoGCD = true,
	FlashColor = "Yellow",
}

a.spells["Shield Barrier"] = {
	ID = 112048--[[Shield Barrier]],
	Buff = 112048--[[Shield Barrier]],
	BuffUnit = "player",
	Check = function(z)
		local charges, maxCharges, timeLastCast, cooldownDuration = GetSpellCharges(2565--[[Shield Block]])
		local recharge_time
		if charges < maxCharges then
			recharge_time = cooldownDuration - GetTime() + timeLastCast
		else
			recharge_time = 0
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and not s.Buff(2565--[[Shield Block]], "player") and x.wha > s.MaxHealth("player") / 20 and (x.wha >= x.whb or (charges == 0 and recharge_time > x.GCD))
	end,
	NoGCD = true,
	FlashColor = "Yellow",
}

a.spells["Demoralizing Shout"] = {
	ID = 1160--[[Demoralizing Shout]],
	MyDebuff = 1160--[[Demoralizing Shout]],
	Check = function(z)
		return x.ShouldTemporaryBuff and x.ActiveEnemy and not s.Buff(2565--[[Shield Block]], "player") and not s.Buff(112048--[[Shield Barrier]], "player") and x.Rage <= 20
	end,
	Melee = true,
	EnemyTargetNeeded = true,
	NoGCD = true,
	FlashColor = "Yellow",
}

a.spells["Taunt"] = {
	ID = 355--[[Taunt]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return s.Form(71--[[Defensive Stance]]) and x.NoCC and x.ThreatPercent <= 99 and ( GetNumGroupMembers() > 1 or GetNumSubgroupMembers() > 0 ) and x.InCombat
	end,
	NoGCD = true,
	FlashColor = "Purple",
}

a.spells["Shout for Rage"] = {
	ID = 469--[[Commanding Shout]],
	EnemyTargetNeeded = true,
	Check = function(z)
		if s.MyBuff(469--[[Commanding Shout]], "raid") then
			z.FlashID = 469--[[Commanding Shout]]
		elseif s.MyBuff(6673--[[Battle Shout]], "raid") then
			z.FlashID = 6673--[[Battle Shout]]
		else
			z.FlashID = {469--[[Commanding Shout]], 6673--[[Battle Shout]]}
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and x.Rage <= x.MaxRage - 25
	end,
}

a.spells["battle_shout,if=rage<70&!debuff.colossus_smash.up"] = {
	ID = 469--[[Commanding Shout]],
	EnemyTargetNeeded = true,
	Check = function(z)
		if s.MyBuff(469--[[Commanding Shout]], "raid") then
			z.FlashID = 469--[[Commanding Shout]]
		elseif s.MyBuff(6673--[[Battle Shout]], "raid") then
			z.FlashID = 6673--[[Battle Shout]]
		else
			z.FlashID = {469--[[Commanding Shout]], 6673--[[Battle Shout]]}
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and x.Rage < 70 and x.DebuffColossusSmashRemains <= x.GCD
	end,
}

a.spells["battle_shout,if=rage<70"] = {
	ID = 469--[[Commanding Shout]],
	EnemyTargetNeeded = true,
	Check = function(z)
		if s.MyBuff(469--[[Commanding Shout]], "raid") then
			z.FlashID = 469--[[Commanding Shout]]
		elseif s.MyBuff(6673--[[Battle Shout]], "raid") then
			z.FlashID = 6673--[[Battle Shout]]
		else
			z.FlashID = {469--[[Commanding Shout]], 6673--[[Battle Shout]]}
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and x.Rage < 70
	end,
}

a.spells["Commanding Shout"] = {
	ID = 469--[[Commanding Shout]],
	Buff = a.StaminaBuffs,
	EarlyRefresh = 10,
	NoRangeCheck = true,
	BuffUnit = "raid",
	FlashColor = "Green",
	Check = function(z)
		return not s.MyBuff(6673--[[Battle Shout]], "raid")
	end,
}

a.spells["Battle Shout"] = {
	ID = 6673--[[Battle Shout]],
	Buff = a.APBuffs,
	EarlyRefresh = 10,
	NoRangeCheck = true,
	BuffUnit = "raid",
	FlashColor = "Green",
	Check = function(z)
		return not s.MyBuff(469--[[Commanding Shout]], "raid")
	end,
}

a.spells["Recklessness"] = {
	ID = 1719--[[Recklessness]],
	Buff = 1719--[[Recklessness]],
	BuffUnit = "player",
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		if s.Boss("target") then
			z.FlashColor = "Yellow"
			z.Continue = false
		else
			z.FlashColor = "Pink"
			z.Continue = true
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and (x.TimeToDie <= 18 or ((x.TimeToDie >= 186 or (x.TargetPCT < 20 and (x.DebuffColossusSmashRemains >= 5 or x.CooldownColossusSmashRemains <= 1.5))) and (not s.HasTalent(12292--[[Bloodbath]]) or s.SpellCooldown(12292--[[Bloodbath]]) == 0)))
	end,
	NoGCD = true,
}

a.spells["recklessness,if=!talent.bloodbath.enabled&((cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5)&(target.time_to_die>(192*buff.cooldown_reduction.value)|target.health.pct<20))|buff.bloodbath.up&(target.time_to_die>(192*buff.cooldown_reduction.value)|target.health.pct<20)|target.time_to_die<=12"] = {
	ID = 1719--[[Recklessness]],
	Buff = 1719--[[Recklessness]],
	BuffUnit = "player",
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		if s.Boss("target") then
			z.FlashColor = "Yellow"
			z.Continue = false
		else
			z.FlashColor = "Pink"
			z.Continue = true
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and (not s.HasTalent(12292--[[Bloodbath]]) and ((x.CooldownColossusSmashRemains < 2 or x.DebuffColossusSmashRemains >= 5) and (x.TimeToDie > (192 * x.CooldownReduction) or x.TargetPCT < 20)) or s.BuffDuration(12292--[[Bloodbath]], "player") > 0 and (x.TimeToDie > (192 * x.CooldownReduction) or x.TargetPCT < 20) or x.TimeToDie <= 12)
	end,
	NoGCD = true,
}

a.spells["avatar,if=enabled&(buff.recklessness.up|target.time_to_die<=25)"] = {
	ID = 107574--[[Avatar]],
	Buff = 107574--[[Avatar]],
	BuffUnit = "player",
	EnemyTargetNeeded = true,
	Check = function(z)
		if s.Boss("target") then
						z.FlashColor = "Yellow"
			z.Continue = false
		else
			z.FlashColor = "Pink"
			z.Continue = true
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and s.HasTalent(107574--[[Avatar]]) and (x.BuffRecklessnessRemains > 0 or x.TimeToDie <= 25)
	end,
	NoGCD = true,
}

a.spells["Bloodbath"] = {
	ID = 12292--[[Bloodbath]],
	Buff = 12292--[[Bloodbath]],
	BuffUnit = "player",
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		if s.Boss("target") then
			z.FlashColor = "Yellow"
			z.Continue = false
		else
			z.FlashColor = "Pink"
			z.Continue = true
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and s.HasTalent(12292--[[Bloodbath]]) and (x.TimeToDie <= 18 or x.BuffRecklessnessRemains > 0 or x.TimeToDie >= 75)
	end,
	NoGCD = true,
}

a.spells["bloodbath,if=enabled&(cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5|target.time_to_die<=20)"] = {
	ID = 12292--[[Bloodbath]],
	Buff = 12292--[[Bloodbath]],
	BuffUnit = "player",
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		if s.Boss("target") then
			z.FlashColor = "Yellow"
			z.Continue = false
		else
			z.FlashColor = "Pink"
			z.Continue = true
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and s.HasTalent(12292--[[Bloodbath]]) and (x.CooldownColossusSmashRemains < 2 or x.DebuffColossusSmashRemains >= 5 or x.TimeToDie <= 20)
	end,
	NoGCD = true,
}

a.spells["Bloodbath (prot)"] = {
	ID = 12292--[[Bloodbath]],
	Buff = 12292--[[Bloodbath]],
	BuffUnit = "player",
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		if s.Boss("target") then
			z.FlashColor = "Yellow"
			z.Continue = false
		else
			z.FlashColor = "Pink"
			z.Continue = true
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy
	end,
	NoGCD = true,
}

a.spells["Skull Banner"] = {
	ID = 114207--[[Skull Banner]],
	Check = function(z)
		if s.Boss("target") then
			z.FlashColor = "Yellow"
			z.Continue = false
		else
			z.FlashColor = "Pink"
			z.Continue = true
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and x.BuffRecklessnessRemains > 0
	end,
	NoRangeCheck = true,
	NoGCD = true,
}

a.spells["skull_banner,if=buff.skull_banner.down&(((cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5)&target.time_to_die>192&buff.cooldown_reduction.up)|buff.recklessness.up)"] = {
	ID = 114207--[[Skull Banner]],
	Buff = 114206--[[Skull Banner]],
	Check = function(z)
		if s.Boss("target") then
			z.FlashColor = "Yellow"
			z.Continue = false
		else
			z.FlashColor = "Pink"
			z.Continue = true
		end
		return x.ShouldTemporaryBuff and x.ActiveEnemy and (((x.CooldownColossusSmashRemains < 2 or x.DebuffColossusSmashRemains >= 5) and x.TimeToDie >192 and x.CooldownReduction < 1) or x.BuffRecklessnessRemains > 0)
	end,
	NoRangeCheck = true,
	NoGCD = true,
}

a.spells["heroic_leap,if=debuff.colossus_smash.up"] = {
	ID = 52174--[[Heroic Leap]],
	RequireMyDebuff = 86346--[[Colossus Smash]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return s.SpellCooldown(52174--[[Heroic Leap]]) == 0 and not s.MeleeDistance("target")
	end,
	FlashColor = "Yellow",
	NoRangeCheck = true,
	Continue = true,
	NoGCD = true,
}


a.spells["Heroic Leap (prot)"] = {
	ID = 52174--[[Heroic Leap]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC
	end,
	FlashColor = "Yellow",
	NoRangeCheck = true,
	Continue = true,
	NoGCD = true,
}

a.spells["Heroic Strike"] = {
	ID = 78--[[Heroic Strike]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and ((x.DebuffColossusSmashRemains > 0 and x.Rage >= x.MaxRage - 40 and x.TargetPCT >= 20) or x.Rage >= x.MaxRage - 15)
	end,
	FlashColor = "Yellow",
	NoGCD = true,
	Continue = true,
	FlashID = {78--[[Heroic Strike]], 845--[[Cleave]]},
}

a.spells["heroic_strike,if=((debuff.colossus_smash.up&rage>=40)&target.health.pct>=20)|rage>=100&buff.enrage.up"] = {
	ID = 78--[[Heroic Strike]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and (((x.DebuffColossusSmashRemains > 0 and x.Rage >= 40) and x.TargetPCT >= 20) or x.Rage >= 100 and x.EnrageRemains > 0)
	end,
	FlashColor = "Yellow",
	NoGCD = true,
	Continue = true,
	FlashID = {78--[[Heroic Strike]], 845--[[Cleave]]},
}

a.spells["Heroic Strike (prot)"] = {
	ID = 78--[[Heroic Strike]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and (x.Rage >= x.MaxRage - 20 or s.Buff(122510--[[Ultimatum]], "player"))
	end,
	FlashColor = "Yellow",
	NoGCD = true,
}

a.spells["Cleave (prot)"] = {
	ID = 845--[[Cleave]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and (x.Rage >= x.MaxRage - 20 or s.Buff(122510--[[Ultimatum]], "player"))
	end,
	FlashColor = "Yellow",
	NoGCD = true,
}

a.spells["Cleave"] = {
	ID = 845--[[Cleave]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.Rage > x.MaxRage - 10
	end,
	FlashColor = "Yellow",
	NoGCD = true,
}

a.spells["Mortal Strike"] = {
	ID = 12294--[[Mortal Strike]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC
	end,
}

a.spells["raging_blow,if=buff.raging_blow.stack=2&debuff.colossus_smash.up&target.health.pct>=20"] = {
	ID = 85288--[[Raging Blow]],
	RequireMyDebuff = 86346--[[Colossus Smash]],
	ConsumeBuff = 131116--[[Raging Blow]],
	ConsumeStack = 2,
	ConsumeStackTaken = 1,
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.TargetPCT >= 20
	end,
}

a.spells["raging_blow,if=target.health.pct<20|buff.raging_blow.stack=2|(debuff.colossus_smash.up|(cooldown.bloodthirst.remains>=1&buff.raging_blow.remains<=3))"] = {
	ID = 85288--[[Raging Blow]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and (x.TargetPCT < 20 or s.BuffStack(131116--[[Raging Blow]], "player") == 2 or (x.DebuffColossusSmashRemains > x.GCD or (x.CooldownBloodthirstRemains >= 1 + x.GCD and s.BuffDuration(131116--[[Raging Blow]], "player") <= 3 + x.GCD)))
	end,
}

a.spells["raging_blow,if=cooldown.colossus_smash.remains>=3"] = {
	ID = 85288--[[Raging Blow]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.CooldownColossusSmashRemains >= 3 + x.GCD
	end,
}

a.spells["bloodthirst,if=!(target.health.pct<20&debuff.colossus_smash.up&rage>=30&buff.enrage.up)"] = {
	ID = 23881--[[Bloodthirst]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and not (x.TargetPCT < 20 and x.DebuffColossusSmashRemains > x.GCD and x.Rage >=30 and x.EnrageRemains > x.GCD)
	end,
}

a.spells["wait,sec=cooldown.bloodthirst.remains,if=!(target.health.pct<20&debuff.colossus_smash.up&rage>=30&buff.enrage.up)&cooldown.bloodthirst.remains<=1&cooldown.bloodthirst.remains"] = {
	ID = 23881--[[Bloodthirst]],
	EnemyTargetNeeded = true,
	Override = function(z)
		return x.CooldownBloodthirstRemains > x.GCD and x.CooldownBloodthirstRemains <= 1 + x.GCD and not (x.TargetPCT < 20 and x.DebuffColossusSmashRemains > x.GCD and x.Rage >= 30 and x.EnrageRemains > x.GCD)
	end,
	FlashBrightness = 0,
}

a.spells["wild_strike,if=buff.bloodsurge.react&target.health.pct>=20&cooldown.bloodthirst.remains<=1"] = {
	ID = 100130--[[Wild Strike]],
	ConsumeBuff = 46916--[[Bloodsurge]],
	ConsumeBuffUnit = "player",
	ConsumeStackTaken = 1,
	ConsumeStackGiven = 2,
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.TargetPCT >= 20 and x.CooldownBloodthirstRemains <= 1 + x.GCD
	end,
}

a.spells["wild_strike,if=buff.bloodsurge.up"] = {
	ID = 100130--[[Wild Strike]],
	ConsumeBuff = 46916--[[Bloodsurge]],
	ConsumeBuffUnit = "player",
	ConsumeStackTaken = 1,
	ConsumeStackGiven = 2,
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC
	end,
}

a.spells["wild_strike,if=debuff.colossus_smash.up&target.health.pct>=20"] = {
	ID = 100130--[[Wild Strike]],
	RequireMyDebuff = 86346--[[Colossus Smash]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.TargetPCT >= 20
	end,
}

a.spells["wild_strike,if=cooldown.colossus_smash.remains>=2&rage>=70&target.health.pct>=20"] = {
	ID = 100130--[[Wild Strike]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.CooldownColossusSmashRemains >= 2 + x.GCD and x.Rage >= 70 and x.TargetPCT >= 20
	end,
}

a.spells["colossus_smash"] = {
	ID = 86346--[[Colossus Smash]],
	MyDebuff = 86346--[[Colossus Smash]],
	EnemyTargetNeeded = true,
	EarlyRefresh = 1,
	Check = function(z)
		return x.NoCC
	end,
}

a.spells["Execute w/ CS or Recklessness or high Rage"] = {
	ID = 5308--[[Execute]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and (x.DebuffColossusSmashRemains > x.GCD or x.BuffRecklessnessRemains > x.GCD or x.Rage >= x.MaxRage - 25)
	end,
}

a.spells["Execute w/o Sudden Execute"] = {
	ID = 5308--[[Execute]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and not s.Buff(139958--[[Sudden Execute]], "player")
	end,
}

a.spells["execute,if=debuff.colossus_smash.up|rage>70|target.time_to_die<12"] = {
	ID = 5308--[[Execute]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and (x.DebuffColossusSmashRemains > x.GCD or x.Rage > 70 or x.TimeToDie < 12)
	end,
}

a.spells["Execute (prot)"] = {
	ID = 5308--[[Execute]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.Rage > x.MaxRage - 20
	end,
}

a.spells["storm_bolt,if=enabled&buff.cooldown_reduction.up&debuff.colossus_smash.up"] = {
	ID = 107570--[[Storm Bolt]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(107570--[[Storm Bolt]]) and x.CooldownReduction < 1 and x.DebuffColossusSmashRemains > x.GCD
	end,
}

a.spells["storm_bolt,if=enabled&buff.cooldown_reduction.down&debuff.colossus_smash.up"] = {
	ID = 107570--[[Storm Bolt]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(107570--[[Storm Bolt]]) and x.CooldownReduction == 1 and x.DebuffColossusSmashRemains > x.GCD
	end,
}

a.spells["storm_bolt,if=enabled&buff.cooldown_reduction.down"] = {
	ID = 107570--[[Storm Bolt]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(107570--[[Storm Bolt]]) and x.CooldownReduction == 1
	end,
}

a.spells["Storm Bolt (prot)"] = {
	ID = 107570--[[Storm Bolt]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(107570--[[Storm Bolt]]) and not s.MeleeDistance("target")
	end,
}

a.spells["Overpower"] = {
	ID = 7384--[[Overpower]],
--	ConsumeMyBuff = 60503--[[Taste For Blood]],
--	ConsumeBuffUnit = "player",
--	ConsumeStack = 3,
	EnemyTargetNeeded = true,
--	EvenIfNotUsable = true,
	Override = function(z)
		return x.NoCC and x.TargetPCT >= 20 and x.Rage >= 10 and s.BuffStack(60503--[[Taste For Blood]], "player") >= 3
	end,
}

a.spells["Overpower w/ Sudden Execute"] = {
	ID = 7384--[[Overpower]],
	EnemyTargetNeeded = true,
	Override = function(z)
		return x.NoCC and (s.BuffDuration(139958--[[Sudden Execute]], "player") > x.GCD or (x.TargetPCT >= 20 and s.Buff(60503--[[Taste For Blood]], "player") )) and x.Rage >= 10
	end,
}

a.spells["Shockwave"] = {
	ID = 46968--[[Shockwave]],
	EnemyTargetNeeded = true,
	Check = function(z)
		if x.AoE > 2 then
			z.Continue = false
			z.FlashColor = "white"
		else
			z.Continue = true
			z.FlashColor = "Pink"
		end
		return x.NoCC and s.HasTalent(46968--[[Shockwave]])
	end,
}

a.spells["shockwave,if=enabled"] = {
	ID = 46968--[[Shockwave]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(46968--[[Shockwave]])
	end,
}

a.spells["Dragon Roar"] = {
	ID = 118000--[[Dragon Roar]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		if x.AoE > 2 then
			z.Continue = false
			z.FlashColor = "white"
		else
			z.Continue = true
			z.FlashColor = "Pink"
		end
		return x.NoCC and s.HasTalent(118000--[[Dragon Roar]])
	end,
}

a.spells["Dragon Roar w/ Bloodbath up and CS down"] = {
	ID = 118000--[[Dragon Roar]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(118000--[[Dragon Roar]]) and s.BuffDuration(12292--[[Bloodbath]], "player") > x.GCD and x.DebuffColossusSmashRemains <= x.GCD and x.TargetPCT >= 20
	end,
}

a.spells["dragon_roar,if=enabled&(!debuff.colossus_smash.up&(buff.bloodbath.up|!talent.bloodbath.enabled))"] = {
	ID = 118000--[[Dragon Roar]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(118000--[[Dragon Roar]]) and (x.DebuffColossusSmashRemains <= x.GCD and (s.BuffDuration(12292--[[Bloodbath]], "player") > x.GCD or not s.HasTalent(12292--[[Bloodbath]])))
	end,
}

a.spells["Dragon Roar w/ Bloodbath up or CS down during Execute"] = {
	ID = 118000--[[Dragon Roar]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(118000--[[Dragon Roar]]) and ((s.Buff(12292--[[Bloodbath]], "player") and x.TargetPCT >= 20) or (x.DebuffColossusSmashRemains <= x.GCD and x.TargetPCT < 20))
	end,
}

a.spells["Dragon Roar w/ Bloodbath"] = {
	ID = 118000--[[Dragon Roar]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(118000--[[Dragon Roar]]) and s.HasTalent(12292--[[Bloodbath]]) and s.Buff(12292--[[Bloodbath]], "player")
	end,
}

a.spells["Slam w/ CS running out or Recklessness"] = {
	ID = 1464--[[Slam]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.DebuffColossusSmashRemains > x.GCD and (x.DebuffColossusSmashRemains < (1 + x.GCD) or x.BuffRecklessnessRemains > x.GCD) and x.TargetPCT >= 20
	end,
}

a.spells["Slam w/ low duration on CS"] = {
	ID = 1464--[[Slam]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.DebuffColossusSmashRemains > x.GCD and x.DebuffColossusSmashRemains < (2.5 + x.GCD) and x.TargetPCT >= 20 and s.BuffStack(60503--[[Taste For Blood]], "player") < 3
	end,
}

a.spells["Slam w/ Rage >= 40"] = {
	ID = 1464--[[Slam]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.Rage >= 40 and x.TargetPCT >= 20 and not s.Buff(60503--[[Taste For Blood]], "player")
	end,
}

a.spells["Heroic Throw"] = {
	ID = 57755--[[Heroic Throw]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC
	end,
}

a.spells["heroic_throw,if=debuff.colossus_smash.down&rage<60"] = {
	ID = 57755--[[Heroic Throw]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.DebuffColossusSmashRemains <= x.GCD and x.Rage < 60
	end,
}

a.spells["Bladestorm"] = {
	ID = 46924--[[Bladestorm]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(46924--[[Bladestorm]]) and x.CooldownColossusSmashRemains >= 5 and x.DebuffColossusSmashRemains == 0 and x.TargetPCT >= 20
	end,
}

a.spells["bladestorm,if=enabled&cooldown.bloodthirst.remains>2"] = {
	ID = 46924--[[Bladestorm]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(46924--[[Bladestorm]]) and x.CooldownBloodthirstRemains > 2 + x.GCD
	end,
}

a.spells["Slam"] = {
	ID = 1464--[[Slam]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.TargetPCT >= 20
	end,
}

a.spells["shattering_throw,if=cooldown.colossus_smash.remains>5"] = {
	ID = 64382--[[Shattering Throw]],
	EnemyTargetNeeded = true,
	Check = function(z)
		return x.NoCC and x.CooldownColossusSmashRemains > 5 + x.GCD
	end,
}

a.spells["Impending Victory"] = {
	ID = 103840--[[Impending Victory]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(103840--[[Impending Victory]]) and x.TargetPCT >= 20
	end,
}

a.spells["impending_victory,if=enabled&target.health.pct>=20&cooldown.colossus_smash.remains>=2"] = {
	ID = 103840--[[Impending Victory]],
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC and s.HasTalent(103840--[[Impending Victory]]) and x.TargetPCT >= 20 and x.CooldownColossusSmashRemains >= 2 + x.GCD
	end,
}

a.spells["mogu_power_potion,if=(target.health.pct<20&buff.recklessness.up)|target.time_to_die<=25"] = {
	Type = "item",
	ID = 76095--[[Potion of Mogu Power]],
	Buff = 105706--[[Potion of Mogu Power]],
	BuffUnit = "player",
	EnemyTargetNeeded = true,
	NoGCD = true,
	Check = function(z)
		return x.ShouldTemporaryBuff and x.ActiveEnemy and s.Boss()
	end,
	CheckLast = function(z)
		return (x.TargetPCT < 20 and x.BuffRecklessnessRemains > 0) or x.TimeToDie <= 25
	end,
	FlashColor = "Yellow",
	Continue = true,
}

a.spells["Victory Rush w/ low health"] = {
	ID = 34428--[[Victory Rush]],
	ComsumeBuff = 32216--[[Victorious]],
	ComsumeBuffUnit = "player",
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC and s.HealthPercent("player") <= 80
	end,
}

a.spells["Victory Rush as Filler"] = {
	ID = 34428--[[Victory Rush]],
	ComsumeBuff = 32216--[[Victorious]],
	ComsumeBuffUnit = "player",
	EnemyTargetNeeded = true,
	Melee = true,
	Check = function(z)
		return x.NoCC and s.HealthPercent("player") < 100 and (x.AoE < 2 or s.BuffDuration(32216--[[Victorious]], "player") < 3)
	end,
}

a.spells["Spell Reflection"] = {
	ID = 23920--[[Spell Reflection]],
	Check = function(z)
		if s.Casting(nil, "target") and s.UnitInfo("targettarget") == s.UnitInfo("player") then
			return true
		end
		if s.InParty() then
			local i
			for i = 1, 4 do
				if s.Casting(nil, "party"..i.."target") and UnitIsEnemy("player","party"..i.."target") and s.UnitInfo("party"..i.."targettarget") == s.UnitInfo("player") then
					return true
				end
			end
		end
	end,
	NoGCD = true,
	FlashColor = "Aqua",
}

a.spells["blood_fury,if=buff.bloodbath.up|(!talent.bloodbath.enabled&debuff.colossus_smash.up)"] = {
	ID = 20572--[[Blood Fury]],
	Buff = 20572--[[Blood Fury]],
	BuffUnit = "player",
	NoRangeCheck = true,
	Check = function(z)
		return x.InCombat and x.ActiveEnemy and (s.BuffDuration(12292--[[Bloodbath]], "player") > x.GCD or (not s.HasTalent(12292--[[Bloodbath]]) and x.DebuffColossusSmashRemains > 0))
	end,
	NoGCD = true,
	FlashColor = "Yellow",
	Continue = true,
}